=== qa/workunits/Makefile ===
DIRS = direct_io fs

all:
	for d in $(DIRS) ; do ( cd $$d ; $(MAKE) all ) ; done
