=== debian/changelog ===
ceph (10.2.11-0ubuntu0.16.04.3) xenial-security; urgency=medium

  * SECURITY UPDATE: XSS attacks
    - debian/patches/CVE-2020-1760-1.patch: reject unauthenticated
      response-header actions in src/rgw/rgw_rest_s3.cc.
    - debian/patches/CVE-2020-1760-2.patch: change EPERM to
      ERR_INVALID_REQUEST in src/rgw/rgw_rest_s3.cc.
    - debian/patches/CVE-2020-1760-3.patch: reject control characters in
      response-header actions in src/rgw/rgw_rest_s3.cc.
    - CVE-2020-1760
  * SECURITY UPDATE: HTTP header injection
    - debian/patches/CVE-2020-10753.patch: sanitize newlines in
      src/rgw/rgw_cors.cc.
    - CVE-2020-10753

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 09 Sep 2020 08:57:28 -0400

ceph (10.2.11-0ubuntu0.16.04.2) xenial-security; urgency=medium

  * SECURITY UPDATE: incorrect permissions on dm-crypt keys
    - debian/patches/CVE-2018-14662.patch: limit caps allowed to access the
      store in qa/suites/rados/singleton/all/mon-config-key-caps.yaml,
      qa/workunits/mon/test_config_key_caps.sh, src/mon/MonCap.cc.
    - CVE-2018-14662
  * SECURITY UPDATE: DoS against OMAPs holding bucket indices
    - debian/patches/CVE-2018-16846-pre1.patch: enforce bounds on
      max-keys/max-uploads/max-parts in src/rgw/rgw_op.cc,
      src/rgw/rgw_op.h, src/rgw/rgw_rest.cc, src/rgw/rgw_rest_swift.cc,
      src/common/config_opts.h.
    - debian/patches/CVE-2018-16846.patch: fix issues with 'enforce bounds'
      patch in src/rgw/rgw_op.cc, src/rgw/rgw_op.h, src/rgw/rgw_rest.cc.
    - CVE-2018-16846

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 29 May 2019 12:06:34 -0400

ceph (10.2.11-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream point release (LP: #1784401).
    - d/p/*: Refresh.
  * Resolve build hang with RocksDB under i386:
    - d/p/0001-CoreLocalArray-class.patch
      d/p/0002-core-local-array-type-conversions.patch
      d/p/0003-Core-local-statistics.patch: Selected cherry picks
      from later Ceph releases with same issue.

 -- James Page <james.page@ubuntu.com>  Tue, 09 Oct 2018 10:10:23 +0100

ceph (10.2.10-0ubuntu0.16.04.1) xenial; urgency=medium

  * d/watch: Scope to 10.2.x series, use tarball download site.
  * New upstream point release (LP: #1780930).

 -- James Page <james.page@ubuntu.com>  Wed, 11 Jul 2018 11:10:52 +0100

ceph (10.2.9-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream point release (LP: #1706566):
    - d/p/sleep-recover.patch: Drop, superceeded by upstream fix.

 -- James Page <james.page@ubuntu.com>  Tue, 26 Sep 2017 07:39:00 +0100

ceph (10.2.7-0ubuntu0.16.04.1) xenial; urgency=medium

  [ Billy Olsen ]
  * Start ceph-all after static-network-up (LP: #1636322):
    - d/p/start-ceph-all-after-network.patch: add dependency on
      the static-network-up event before starting ceph-all.

  [ James Page ]
  * New upstream point release (LP: #1684527):
    - d/p/disable-openssl-linking.patch: Dropped, no longer required.
    - d/control: Add BD on libssl-dev to support optional runtime
      loading of openssl in the radosgw.

 -- James Page <james.page@ubuntu.com>  Fri, 21 Apr 2017 09:21:10 +0100

ceph (10.2.6-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream stable point release (LP: #1671117):
    - d/p/osd-limit-omap-data-in-push-op.patch,rgw_rados-creation_time.patch:
      Dropped, included upstream.
    - d/p/*: Refresh.

 -- James Page <james.page@ubuntu.com>  Thu, 09 Mar 2017 16:21:36 +0000

ceph (10.2.5-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream stable release (LP: #1649856):
    - d/p/32bit-ftbfs.patch: Drop, no longer required.
    - d/p/*: Refresh.
    - d/ceph-common.install: Switch to RSA keys for drop.ceph.com.
  * d/rules: Install upstream provided systemd targets and ensure they
    are enabled and started on install to ensure that integrations aligned
    to upstream packaging work with Ubuntu packages (LP: #1646583).
  * d/ceph.*,d/*.logrotate: Install logrotate configuration
    in ceph-common, ensuring that all daemons get log rotation on
    log files, deal with removal of logrotate configuration in
    ceph for upgrades (LP: #1609866).

 -- James Page <james.page@ubuntu.com>  Wed, 14 Dec 2016 11:42:36 +0000

ceph (10.2.3-0ubuntu0.16.04.2) xenial; urgency=medium

  * rgw: Fixes for creation times for buckets (LP: #1587261):
    - d/p/rgw_rados-creation_time.patch: Backport fix from upstream master.
      Fix logic error that leads to creation time being 0 instead of current
      time when creating buckets.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Fri, 28 Oct 2016 13:50:40 +0200

ceph (10.2.3-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream stable release (LP: #1628809).
    - d/p/*: Refresh.
    - d/p/rocksdb-flags.patch: Dropped, accepted upstream.
    - d/p/32bit-ftbfs.patch: Cherry pick fix for 32bit arch compat.
    - d/ceph-{fs-common,fuse}.install: Fix install locations
      for mount{.fuse}.ceph.
  * Limit the amount of data per chunk in omap push operations to 64k,
    ensuring that OSD threads don't hit timeouts during recovery
    operations (LP: #1628750):
    - d/p/osd-limit-omap-data-in-push-op.patch: Cherry pick fix from
      upstream master branch.

 -- James Page <james.page@ubuntu.com>  Fri, 30 Sep 2016 09:22:50 +0100

ceph (10.2.2-0ubuntu0.16.04.2) xenial; urgency=medium

  * d/ceph-common.{preinst,postinst,postrm}: Fix version checks in maintainer
    scripts to ensure that /etc/default/ceph actually gets installed on
    upgrade (LP: #1587516).

 -- James Page <james.page@ubuntu.com>  Tue, 19 Jul 2016 10:32:34 +0100

ceph (10.2.2-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream stable release (LP: #1585660).
    - d/p/drop-user-group-osd-prestart.patch: Dropped, included upstream.
    - d/ceph.install: Drop install of 60-ceph-partuuid-workaround.rules, no
      longer needed and not shipped by upstream.
  * Rename /etc/default/ceph/ceph -> /etc/default/ceph (LP: #1587516):

