=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/" \
 http://download.ceph.com/tarballs/ceph-(10\.2\.\d.*)\.tar\.gz
